/*
Simple non code license (SNCL) Version 1.10.0

Copyright (C) 2019 Shouvick Mondal, and Rupesh Nasre.

The original creator(s) of the data or text under this license is thereby
called the licensor.

The person physical or juridical obtaining a copy of the data or text
under this license is thereby called the licensee.

The data or text under this license is therefore called the object.

1. The licensee rights and obligations
1.1. The licensee have the right to obtain a free copy of the object.
1.2. It is a right of the licensee to redistribute unaltered copies of
     the object although commercial use is utterly forbidden
     (except with licensor express written consent).
1.3. The licensee is given the right to adapt or modify the object to
     suit his needs and to redistribute the modified version subject to
     the following conditions:
1.3.1. You must keep the following notice in any copy of the object that
       you may create: Written originally by Shouvick Mondal, and Rupesh Nasre
       on 2019-04-16.
1.3.2. You must keep a changelog somewhere inside the modified object in
       the following format: {version} {YYYY-MM-DD HH:MM (24 hours cycle)}
       {Description} {pages changed list}.
1.3.3. The same rules about commercial use stated in clause 1.1 applies
       here.
1.3.4. You must include the following notice in any object-modified copies
       you redistribute: This document or data is a derivative of Mahtab
       and the information contained here may or may not represent the
       original document or data.
1.3.5. In case of juridical problems that may arise from licensee edits the
       licensee is liable instead of the licensor.
1.4. The licensee is given the right to redistribute work including any
     licensor copyrights originally contained in the object but not to use
     it on its own behalf. (void if the clause 3 is present)
1.5. All of the above clauses are void if the licensee fails to accomplish
     his obligations established in clause 1.
1.6. If the 1.5 clause becomes true the licensee must pay for any costs the
     licensor may have with juridical actions against him.
2. The liability of the licensor
2.1. The licensor is liable only for what himself wrote regarding juridical
     issues related to injury, racism or offense and any other crimes.
2.2. The licensor is not liable for the content that was edited by third
     parties and the liability for such cases falls over the licensee as
     described in 1.3.5.
*/

struct timeval memset_beg,memset_end; // 3*memset()
struct timeval strcpy_beg,strcpy_end; // strcpy()
struct timeval strcat_beg,strcat_end; // strcat()
struct timeval fopen_beg,fopen_end; // fopen()
struct timeval fscanf_beg,fscanf_end; //fscanf()
struct timeval fclose_beg,fclose_end; //fclose()
struct timeval sprintf_beg,sprintf_end; //sprintf()
struct timeval system_beg,system_end; //system()

double time_memset=0.0;
double time_strcpy=0.0;
double time_strcat=0.0;
double time_fopen=0.0;
double time_fscanf=0.0;
double time_fclose=0.0;
double time_sprintf=0.0;
double time_system=0.0;

struct cov_node
{
	double PER_memset;
	double PER_strcpy;
	double PER_strcat;
	double PER_fopen;
	double PER_fscanf;
	double PER_fclose;
	double PER_sprintf;
	double PER_system;
	
}coverage;

struct cov_node2
{
	double PER_memset;
	double PER_strcpy;
	double PER_strcat;
	double PER_fopen;
	double PER_fscanf;
	double PER_fclose;
	double PER_sprintf;
	
}coverage2;


