#include<stdio.h>
#define NIL -999999
#define WHITE 1
#define GRAY 2
#define BLACK 3
#define MAX 6
int time,color[MAX+1],pi[MAX+1],discovery[MAX+1],finish[MAX+1];
void printforest(int a[],int j)
{
	if(pi[j]==NIL)
	{
		printf("%d",j);
		return;
	}
	else
	{
		printforest(a,pi[j]);
		printf("->%d",j);
	}
}	
int dfs_visit(int g[MAX+1][MAX+1],int u)
{
	int v;
	
	time=time+1;

	discovery[u]=time;
	color[u]=GRAY;
	
	for(v=1;v<=MAX;v++)
	{
		if(g[u][v]==1)
		{
			if(color[v]==WHITE)
			{
				pi[v]=u;
				dfs_visit(g,v);
			}
		}
	}
	color[u]=BLACK;
	time=time+1;

	finish[u]=time;
}	
void dfs(int g[MAX+1][MAX+1])
{
	int u;
	
	for(u=1;u<=MAX;u++)
	{
		color[u]=WHITE;
		pi[u]=NIL;
	}
	time=0;
	
	for(u=1;u<=MAX;u++)
	{
		if(color[u]==WHITE)
		{
			dfs_visit(g,u);
		}
	}
}
int main()
{
	int i,j;
	int g[MAX+1][MAX+1]={{0,0,0,0,0,0,0},
			     {0,0,1,0,0,0,1},
			     {0,0,0,0,0,1,0},
			     {0,0,0,0,1,1,0},
			     {0,0,0,0,1,0,0},
			     {0,0,0,0,0,0,1},
			     {0,0,1,0,0,0,0}};
	
	dfs(g);
			
	for(i=1;i<=MAX;i++)
	{
		switch(color[i])
		{
			case 1:
				printf("\ncolor[%d]:WHITE",i);
				break;
			case 2:	
				printf("\ncolor[%d]:GRAY",i);
				break;
			case 3:
				printf("\ncolor[%d]:BLACK",i);
				break;
		}				
			
	}
	printf("\n");
	for(i=1;i<=MAX;i++)
	{
		if(pi[i]!=NIL)
			printf("\npi[%d]:%d",i,pi[i]);
		else
			printf("\npi[%d]:NIL",i);
	}
	printf("\n");
	for(i=1;i<=MAX;i++)
	{
		printf("\ndiscovery[%d]:%d",i,discovery[i]);
	}
	printf("\n");
	for(i=1;i<=MAX;i++)
	{
		printf("\nfinish[%d]:%d",i,finish[i]);
	}
	printf("\nThe forest is as follows...\n\n");
	
	for(i=1;i<=MAX;i++)
	{
		printf("\n%d is reachable from root=",i);
		printforest(pi,i);
	}
	printf("\n\n");
	return(0);
}
		

