#include<stdio.h>
#include<stdlib.h>
struct polynode
{
	float coeff;
	int exp;
	struct polynode *next;
};
void polyappend(struct polynode **p,float c,int e)
{
	struct polynode *temp;
	temp=*p;

	if(*p==NULL)
	{
	       *p=(struct polynode *)malloc(sizeof(struct polynode));
		temp=*p;
	}
	else
	{
		while(temp->next!=NULL)
		temp=temp->next;

		temp->next=(struct polynode *)malloc(sizeof(struct polynode));
		temp=temp->next;
	}
	temp->coeff=c;
	temp->exp=e;
	temp->next=NULL;

}
void displaypoly(struct polynode *p)
{
	while(p!=NULL)
	{
		if(p->exp!=0)
		printf("%.2fx^%d+",p->coeff,p->exp);
		else
		printf("%.2f",p->coeff);
		p=p->next;
	}
}
void polysub(struct polynode *x,struct polynode *y,struct polynode **z)
{

	struct polynode *temp,*k;
	int choice;
	
	if(x==NULL&&y==NULL)
		return;
	printf("\n\n\n1.Subtract P2 from P1 ie. P3=P1-P2\n");
	printf("2.Subtract P1 from P2 ie. P3=P2-P1\n\n");
	printf("Enter choice:");
	scanf("%d",&choice);
	if(choice==1)
	{
		k=y;
		while(y!=NULL)
		{	
			y->coeff*=-1;
			y=y->next;
		}	
		y=k;
	}
	else
	{
 		if(choice==2)
		{
			k=x;
			while(x!=NULL)
			{	
				x->coeff*=-1;
				x=x->next;
			}
			x=k;
		}
		else
		{
			printf("Wrong Choice!!");
			exit(0);
		}
	}	
	while(x!=NULL&&y!=NULL)
	{
		if(*z==NULL)
		{
			*z=(struct polynode*)malloc(sizeof(struct polynode));
			temp=*z;
		}
		else
		{
			temp->next=(struct polynode *)malloc(sizeof(struct polynode));
			temp=temp->next;
		}
		if(x->exp>y->exp)
		{
			temp->exp=x->exp;
			temp->coeff=x->coeff;
			x=x->next;
		}
		else
		{
			if(x->exp<y->exp)
			{
				temp->exp=y->exp;
				temp->coeff=y->coeff;
				y=y->next;
			}
			else
			{
				if(x->exp==y->exp)
				{
					temp->exp=x->exp;
					temp->coeff=x->coeff+y->coeff;
					x=x->next;
					y=y->next;
				}
			}
		}
		}
		while(x!=NULL)
		{

			if(*z==NULL)
			{
			       *z=(struct polynode *)malloc(sizeof(struct polynode));
				temp=*z;
			}
			else
			{
				temp->next=(struct polynode *)malloc(sizeof(struct polynode));
				temp=temp->next;
			}
			temp->exp=x->exp;
			temp->coeff=x->coeff;
			x=x->next;
		}
		while(y!=NULL)
		{

			if(*z==NULL)
			{
				*z=(struct polynode *)malloc(sizeof(struct polynode));
				temp=*z;
			}
			else
			{
				temp->next=(struct polynode *)malloc(sizeof(struct polynode));
				temp=temp->next;
			}
			temp->exp=y->exp;
			temp->coeff=y->coeff;
			y=y->next;
		}
		temp->next=NULL;
}
int main()
{
	struct polynode *p1,*p2,*p3;
	p1=p2=p3=NULL;

	polyappend(&p1,3.6f,7);
	polyappend(&p1,4.6f,6);
	polyappend(&p1,1.7f,4);
	polyappend(&p1,5.8f,3);
	polyappend(&p1,2.7f,1);
	polyappend(&p1,7.9f,0);
	
	printf("The 1st polynomial:\n");
	displaypoly(p1);

	polyappend(&p2,1.8f,5);
	polyappend(&p2,6.8f,4);
	polyappend(&p2,9.6f,3);
	polyappend(&p2,5.3f,2);
	polyappend(&p2,1.7f,1);
	polyappend(&p2,2.1f,0);

	printf("\n\nThe 2nd polynomial:\n");
	displaypoly(p2);

	polysub(p1,p2,&p3);

	printf("\n\nThe Resultant polynomial after subtraction:\n\n");
	displaypoly(p3);
	printf("\n\n\n");
	return(0);
}


