#include<stdio.h>
#define INF 99999999
#define NIL -99999999
#define max 6
int cost,a[max+1],q[max+1],pi[max+1],key[max+1],size=max,status[max+1];
void display()
{
	int i,j;
		
	printf("\nThe Key list...\n");
	for(i=1;i<=max;i++)
	{
		if(key[i]!=INF)
			printf("\nkey[%d]:%d",i,key[i]);
		else
			printf("\nkey[%d]:INF",i);
	}
	printf("\n");
	printf("\nThe Mininum Cost Spanning tree...\n");
		
	for(i=1;i<=max;i++)
	{
		if(pi[i]!=NIL)
		{
			cost+=key[i];
			printf("\n%d to %d with cost %d",pi[i],i,key[i]);
		}
	}		
	printf("\nTotal Cost=%d\n",cost);
	printf("\nThe predecessor list...\n");
	for(i=1;i<=max;i++)
	{
		if(pi[i]!=NIL)
			printf("\npi[%d]:%d",i,pi[i]);
		else
			printf("\npi[%d]:NIL",i);
	}
	
}
int min_heapify(int i)
{
	int l,r,smallest,temp;

	l=2*i;
	r=l+1;

	if((l<=size)&&(q[l]<q[i]))
		smallest=l;
	else
		smallest=i;
	if((r<=size)&&(q[r]<q[smallest]))
		smallest=r;
	if(smallest!=i)
	{
		temp=q[i];
		q[i]=q[smallest];
		q[smallest]=temp;
		min_heapify(smallest);
	}
}
int extract_min()
{
	int min,iloc;
	if(size<1)
		printf("Heap underflow!!");
	min=q[1];
	q[1]=q[size];
	--size;
	min_heapify(1);
	return(min);
}
void decrease_key(int i,int key)
{
	int temp,parent;
	if(key>q[i])
	{
		printf("new key is greater than current key\n");
		return;	
	}
	q[i]=key;
	parent=i/2;
	while((i>1)&&(q[parent]>q[i]))
	{
		temp=q[parent];
		q[parent]=q[i];
		q[i]=temp;
		i=parent;
	}
}
void prim(int g[max+1][max+1],int w[max+1][max+1],int r)
{
	int u,v,i,j,loc,aux;

	for(u=1;u<=max;u++)
	{
		key[u]=INF;
		pi[u]=NIL;
	}
	key[r]=0;
	
	for(i=1;i<=max;i++)
		q[i]=key[i];
	
	j=q[r];
	q[r]=q[1];
	q[1]=j;
	
	while(size!=0)
	{
		u=extract_min();
		for(j=1;j<=max;j++)
		{
			
			if(key[j]==u)
			{
				loc=j;
				break;
			}
	
			
		}
		status[loc]=0;//vertex u is out of queue
		
		for(v=1;v<=max;v++)
		{
		
			if((g[loc][v]>0)&&(g[loc][v]<INF))
			{
				if((status[v]==1)&&(g[loc][v]<key[v]))
				{
					pi[v]=loc;
					key[v]=g[loc][v];
					decrease_key(v,key[v]);
				}
			}
				
		}
				
		
	}
}
main()
{
	int g[max+1][max+1]={{0,0,0,0,0,0,0},
			     {0,0,10,16,11,10,17},
			     {0,10,0,9,INF,INF,19},
			     {0,16,9,0,7,INF,12},
			     {0,11,INF,7,0,8,7},
			     {0,10,INF,INF,8,0,9},
			     {0,17,19.5,12,7,9,0}};
			     		     
	int r,i;
	r=1;
	cost=0;
	for(i=1;i<=max;i++)
		status[i]=1;

	prim(g,g,r);
	display();
	printf("\n\n");
}
