#include<stdio.h>
#include<stdlib.h>
struct node 
{
	int data;
	struct node *next;
};
void delete(struct node **f,struct node **r)
{
	struct node *p=NULL;
	int item;

	if(*f==NULL)
	{
		printf("Underflow!!");
		return;
	}
	if(*f==*r)
	{
		item=(*f)->data;
		free(*f);
		*f=NULL;
		*r=NULL;
	}
	else
	{
		p=*f;
		item=p->data;
		(*f)=(*f)->next;
		(*r)->next=(*f);
		free(p);
	}
	printf("\nThe deleted item:%d\n",item);
	
}
void insert(struct node **f,struct node **r,int d)
{
	struct node *p;

	p=(struct node *)malloc(sizeof(struct node));

	p->data=d;

	if(*f==NULL)
	{
		(*r)=p;
		(*f)=p;
		(*r)->next=(*f);
	}
	else
	{
		(*r)->next=p;
		*r=p;
		(*r)->next=*f;
	}
}
void display(struct node *f)
{
	struct node *p,*t=NULL;
	p=f;
	printf("FRONT->");
	while(p!=t)
	{
		printf("%d ",p->data);
		p=p->next;
		t=f;
	}
	printf("<-REAR");
}		
int main()
{
	struct node *front,*rear;
	front=rear=NULL;
	
	printf("\n\nDemonstration of Circular Linked List.......\n\n");	
	delete(&front,&rear);
	insert(&front,&rear,10);
	insert(&front,&rear,17);
	insert(&front,&rear,18);
	insert(&front,&rear,5);
	insert(&front,&rear,30);
	insert(&front,&rear,15);
	printf("\nBefore Deletion!!\n");
	display(front);
	delete(&front,&rear);
	delete(&front,&rear);
	printf("\nAfter Deletion!!\n");
	display(front);
	insert(&front,&rear,90);
	insert(&front,&rear,89);
	printf("\nAfter Insertion!!\n");
	display(front);
	printf("\n\n\n");
	return(0);
}
	
	
	
