#include<stdio.h>
int n,length=7;
void print(int s[n][n],int i,int j)//printing parenthesization
{
	if(i==j)
		printf("A%d",i);
	else
	{
		printf("(");
		print(s,i,s[i][j]);
		print(s,s[i][j]+1,j);
		printf(")");
	}
}
void MatrixChainOrder(int p[])
{
	n=length-1;
	int m[n+1][n+1],s[n][n],i,j,l,q,k,min;

	for(i=1;i<=n;i++)
		m[i][i]=0;

	for(l=2;l<=n;l++)
	{
		for(i=1;i<=n-l+1;i++)
		{
			j=i+l-1;
			m[i][j]=999999999;//infinity
			
			for(k=i;k<=j-1;k++)
			{
				q=m[i][k]+m[k+1][j]+p[i-1]*p[k]*p[j];
				if(q<m[i][j])
				{
					m[i][j]=q;
					s[i][j]=k;	
				}
			}
		}
	}
	printf("The m[][] table.....\n\n");
	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
			if(i<=j)
			{
				printf(" %d ",m[i][j]);
			}
		}
		printf("\n");
	}
	printf("\nThe s[][] table...\n\n");
	for(i=1;i<=n-1;i++)
	{
		for(j=2;j<=n;j++)
		{
			if(i<j)
				printf(" %d ",s[i][j]);
		}
		printf("\n");
	}
	printf("\nThe optimal parenthesization\n\n");
	print(s,1,n);
	min=m[1][n];
	printf("\n\nMinimum scalar multiplications required=%d\n\n",min);
}
int main()
{
	int p[7]={30,35,15,5,10,20,25};//dimensions
	MatrixChainOrder(p);
	return(0);
}
