#include<stdio.h>
#include<stdlib.h>
struct node
{
	int data;
	struct node *next;
};
int count(struct node *n1)
{
	struct node *p=NULL;
	int ct=0;
	p=n1;
	if(n1==NULL)
		printf("Empty linked list!!");
	else
	{
		while(p!=NULL)
		{
			ct++;
			p=p->next;
		}
	}
	return(ct);
}
void largest(struct node *n1)
{
	int max=-32760;
	struct node *p;
	p=n1;

	if(n1==NULL)
		printf("There can be no maximum in an empty linked list!!\n\n");
	else
	{
		while(p!=NULL)
		{
			if(p->data>max)
				max=p->data;
			p=p->next;
		}
		printf("The maximum element in the linked list: %d\n\n",max);
	}
}
void smallest(struct node *n1)
{
	int min=32760;
	struct node *p;
	p=n1;
	
	if(n1==NULL)
		printf("There can be no minimum in an empty linked list!!\n\n");
	else
	{
		while(p!=NULL)
		{
			if(p->data<min)
				min=p->data;
			p=p->next;
		}
		printf("The minimum element in the linked list: %d\n\n",min);
	}
}
void insBeg(struct node **n1,int k)
{
	struct node *p;
	p=(struct node *)malloc(sizeof(struct node));
	p->data=k;
	if(*n1==NULL)
	{
		p->next=NULL;
		*n1=p;
	}
	else
	{
		p->next=*n1;
		*n1=p;
	}
}
void insAny(struct node **n1,int pos,int k)
{
	struct node *p,*q,*save=NULL;
	int i=1;
	q=*n1;
	if(pos<1)
	{
		printf("Invalid position!!\n\n");
		return;
	}
	if(*n1!=NULL&&pos>count(q))
		printf("Position exceeded total count!!");
	else
	{
		p=(struct node *)malloc(sizeof(struct node));
		p->data=k;
		if(pos==1||(*n1==NULL&&pos==1))
		{
			p->next=*n1;
			*n1=p;
		}
		else
		{
			while(i<pos&&q!=NULL)
			{
				save=q;
				q=q->next;
				i++;
			}
			if(q!=NULL)
			{
				save->next=p;
				p->next=q;
			}
			else
				printf("Data Unacceptable!!\n\n");
				
		}
	}
	
}
void deleteData(struct node **n1,int k)
{
	struct node *p,*save=NULL;
	int found=0;
	p=*n1;

	if(*n1==NULL)
	{
		printf("Cannot Delete from empty linked list!!\n\n");
		return;
	}
	else
	{
		if(p->data==k)
	     	{
			found=1;
			*n1=(*n1)->next;
			free(p);
	     	}
	     	else
	     	{	
			while(p!=NULL)
			{	
				if(p->data==k)
				{
					found=1;
					break;
				}
				else
				{
					save=p;
					p=p->next;
				}
		
			}
			if(found==1)
			{
				save->next=p->next;
				free(p);
			}
	     	}
	}
	if(found==0)
		printf("Element not found in linked list!!\n\n");

}
void delAny(struct node **n1,int pos)
{
	struct node *p,*save=NULL;
	int i=1;
	p=*n1;
	if(pos<1)
	{
		printf("Invalid position!!\n\n");
		return;
	}
	if(*n1==NULL)
	{
		printf("Cannot delete from empty linked list!!\n\n");
		return;
	}
	else if(pos>count(p))
		printf("Position exceeded total count!!\n\n");
	else if(pos==1)
	{	
		*n1=(*n1)->next;
		free(p);
	}
	else
	{
		while(i<pos&&p!=NULL)
		{
			save=p;
			p=p->next;
			i++;
		}
		save->next=p->next;
		free(p);
	}
}
void display(struct node *n1)
{
	struct node *p;
	p=n1;
	if(n1==NULL)
		printf("Nothing to display linked list empty!!\n\n");
	else
	{
		while(p!=NULL)
		{
			printf(" %d ",p->data);
			p=p->next;
		}
	}
}
int main()
{
	struct node *n1=NULL;
	int k,pos=1,ch=0,yes=1;

	while(yes==1)
	{
		printf("\n\nMenu\n\n");
		printf("1.Count the number of elements\n");
		printf("2.Find the largest element\n");
		printf("3.Find the smallest element\n");
		printf("4.Insert element at the begining\n");
		printf("5.Insert element at any position\n");
		printf("6.Delete a particular element\n");
		printf("7.Delete an element from any particular position\n");
		printf("8.Display the linked list\n");
		printf("9.Exit\n\n");
		printf("Enter your choice:");
		scanf("%d",&ch);

		switch(ch)
		{
			case 1: printf("Number of elements=%d\n\n",count(n1));
				break;
			case 2: largest(n1);
				break;
			case 3: smallest(n1);
				break;
			case 4: printf("Enter data:");
				scanf("%d",&k);
				insBeg(&n1,k);
				break;
			case 5: printf("Enter data:");
				scanf("%d",&k);
				printf("\nEnter position:");
				scanf("%d",&pos);
				insAny(&n1,pos,k);
				break;
			case 6: printf("Enter the data:");
				scanf("%d",&k);
				deleteData(&n1,k);
				break;
			case 7: printf("Enter the position:");
				scanf("%d",&pos);
				delAny(&n1,pos);
				break;
			case 8: display(n1);
				break;
			case 9: exit(1);
				break;
			default: printf("Wrong Choice!!\n\n");
		}
		printf("\nDo you want to continue(Yes=1/No=0)?");
		scanf("%d",&yes);
			
	}
	return(0);
}	
	
	
		
		
	
