#include<stdio.h>
#include<stdlib.h>
struct node
{
	struct node *prev;
	int data;
	struct node *next;
};
void reverse(struct node *n1)
{
	struct node *p;
	p=n1;

	if(n1==NULL)
		printf("\n\nlinked list empty!!");
	else if(p->prev==NULL&&p->next==NULL)
		printf("\n\nThe only element in linked list: %d",p->data);
	else
	{
		while(p->next!=NULL)
			p=p->next;
		printf("\n\nThe double linked list in reverse order.........\n\n");
		while(p!=NULL)
		{
			printf(" %d ",p->data);
			p=p->prev;
		}
	}
}
void grow(struct node **n1,int k)
{
	
	struct node *p=NULL;
	
	if(*n1==NULL)
	{
		p=(struct node *)malloc(sizeof(struct node));
		p->prev=NULL;
		p->next=NULL;
		p->data=k;
		*n1=p;
	}
	else
	{
		p=(struct node *)malloc(sizeof(struct node));
		p->data=k;
		p->prev=NULL;
		p->next=*n1;
		(*n1)->prev=p;
		*n1=p;
	}
}
void display(struct node *n1)
{
	if(n1==NULL)
		printf("Nothing to Display!!");
	else if(n1->prev==NULL&&n1->next==NULL)
		printf("Only element in linked list: %d",n1->data);
	else
	{	
		printf("The linked list in the normal order!!..........\n\n");
		while(n1!=NULL)
		{
			printf(" %d ",n1->data);
			n1=n1->next;
		}
	}
}
void insAnyPos(struct node **n1,int pos,int k)
{
	struct node *p,*q;
	int i=1;
	q=*n1;
	p=(struct node *)malloc(sizeof(struct node));
	p->data=k;
	if(*n1==NULL)
	{
		p->prev=NULL;
		p->next=NULL;
		*n1=p;
	}
	else if(pos==1)
	{
		p->prev=NULL;
		p->next=q;
		q->prev=p;
		*n1=p;
	}
	else
	{
		while(i<pos&&q->next!=NULL)
		{
			q=q->next;
			i++;
		}
		p->prev=q->prev;
		p->next=q;
		q->prev=p;
		p->prev->next=p;
	}
}
void delete(struct node **n1,int k)
{ 	
	struct node *q,*save=NULL;
	q=*n1;
	int found=0;
	if(*n1==NULL)
	{
		printf("Empty linked list cannot delete!!");
		return;
	}
	else if(q->data==k)
	{
		found=1;
		*n1=(*n1)->next;
		(*n1)->prev=NULL;
	}
	else
	{
		while(q!=NULL)
		{
			save=q;
			if(q->data==k)
			{
				if(q->next!=NULL)
				{
					found=1;
					save->prev->next=save->next;
					save->next->prev=save->prev;
					break;
				}
				else
				{		
					found=1;
					q->prev->next=NULL;
					q->prev=NULL;
					break;
				}
			}
			q=q->next;
		}
	}
	if(found==1)
		free(q);
	else
		printf("Element not found!!");
	
}
int main()
{
	struct node *n1;
	int k,pos,ch,yes=1;

	while(yes!=0)
	{
		printf("\n\nMenu........");
		printf("\n1.Build/Grow linked list");
		printf("\n2.Reverse Display");
		printf("\n3.Normal Display");
		printf("\n4.Delete a particular data");
		printf("\n5.Insert at any position");
		printf("\n6.Exit");
		printf("\nEnter your choice:");
		scanf("%d",&ch);
	
		switch(ch)
		{
			case 1:	printf("Enter data:");
				scanf("%d",&k);
				grow(&n1,k);
				break;
			
			case 2: reverse(n1);
				break;
				
			case 3: display(n1);
				break;
			
			case 4: printf("\nEnter the data to be deleted:");
				scanf("%d",&k);
				delete(&n1,k);
				break;
			
			case 5: printf("\nEnter the data to be inserted:");
				scanf("%d",&k);
				printf("Enter the position:");
				scanf("%d",&pos);
				insAnyPos(&n1,pos,k);
				break;
			
			case 6: exit(1);
				break;
		
			default:
				printf("\nWrong Choice!!");
		}
		printf("\n\nDo you want to continue(Yes=1/No=0)?");
		scanf("%d",&yes);
	}
	return(0);
}
		
