#include<stdio.h>
#define max 5
#define INF 999999
#define NIL -999999
struct a
{
	int d[max+1][max+1];
	int pi[max+1][max+1];
}s[max+1];
int min(int a,int b)
{
	if(a<b)
		return(a);
	else
		return(b);
}
void floyd_warshall(int w[max+1][max+1])
{
	int i,j,k,aux;
	
	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			s[0].d[i][j]=w[i][j];
			if((i==j)||(w[i][j]==INF))
				s[0].pi[i][j]=NIL;
			if((i!=j)&&(w[i][j]<INF))
				s[0].pi[i][j]=i;		
		}
	}
	
	for(k=1;k<=max;k++)
	{
		for(i=1;i<=max;i++)
		{
			for(j=1;j<=max;j++)
			{
				aux=s[k-1].d[i][k]+s[k-1].d[k][j];
				s[k].d[i][j]=min(s[k-1].d[i][j],aux);
				
				if(s[k-1].d[i][j]<=s[k-1].d[i][k]+s[k-1].d[k][j])
					s[k].pi[i][j]=s[k-1].pi[i][j];
				else
					s[k].pi[i][j]=s[k-1].pi[k][j];
			}
		}
	}
	printf("The D(n) matrix....\n\n");
	
	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			if(s[max].d[i][j]!=INF)
				printf(" %d ",s[max].d[i][j]);
			else
				printf("INF");
		}	
		printf("\n");
	}
	printf("\nThe Predecesor matrix...\n\n");

	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			if(s[max].pi[i][j]!=NIL)
				printf(" %d ",s[max].pi[i][j]);
			else
				printf("NIL");
		}
		printf("\n");
	}
	
}
main()
{
	int i,j,g[max+1][max+1];

	printf("Enter the Graph as Weigth Matrix...\n\n");
	
	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			printf("Enter g[%d][%d]:",i,j);
			scanf("%d",&g[i][j]);
		}
	}

	floyd_warshall(g);
	
}
